<?php
/*
* @package   s9e\TextFormatter
* @copyright Copyright (c) 2010-2015 The s9e Authors
* @license   http://www.opensource.org/licenses/mit-license.php The MIT License
*/
namespace s9e\TextFormatter\Bundles\MediaPack;
class Renderer extends \s9e\TextFormatter\Renderer
{
	protected $params=array('AMAZON_ASSOCIATE_TAG'=>'','AMAZON_ASSOCIATE_TAG_CA'=>'','AMAZON_ASSOCIATE_TAG_DE'=>'','AMAZON_ASSOCIATE_TAG_ES'=>'','AMAZON_ASSOCIATE_TAG_FR'=>'','AMAZON_ASSOCIATE_TAG_IT'=>'','AMAZON_ASSOCIATE_TAG_JP'=>'','AMAZON_ASSOCIATE_TAG_UK'=>'');
	protected static $tagBranches=array('ABCNEWS'=>0,'AMAZON'=>1,'AUDIOBOOM'=>2,'AUDIOMACK'=>3,'BANDCAMP'=>4,'BBCNEWS'=>5,'BLEACHERREPORT'=>6,'BLIP'=>7,'BREAK'=>8,'CBSNEWS'=>9,'CNBC'=>10,'CNN'=>11,'CNNMONEY'=>12,'COLBERTNATION'=>13,'COMEDYCENTRAL'=>13,'DAILYSHOW'=>13,'GAMETRAILERS'=>13,'COLLEGEHUMOR'=>14,'COUB'=>15,'DAILYMOTION'=>16,'DEMOCRACYNOW'=>17,'DUMPERT'=>18,'EIGHTTRACKS'=>19,'ESPN'=>20,'ESPNDEPORTES'=>21,'FACEBOOK'=>22,'FLICKR'=>23,'FOXNEWS'=>24,'FUNNYORDIE'=>25,'GAMESPOT'=>26,'GETTY'=>27,'GFYCAT'=>28,'GIST'=>29,'GLOBALNEWS'=>30,'GOFUNDME'=>31,'GOOGLEPLUS'=>32,'GOOGLESHEETS'=>33,'HUDL'=>34,'HULU'=>35,'HUMORTVNL'=>36,'IGN'=>37,'IMDB'=>38,'IMGUR'=>39,'INDIEGOGO'=>40,'INSTAGRAM'=>41,'INTERNETARCHIVE'=>42,'IZLESENE'=>43,'KHL'=>44,'KICKSTARTER'=>45,'KISSVIDEO'=>46,'LIBSYN'=>47,'LIVELEAK'=>48,'LIVESTREAM'=>49,'MAILRU'=>50,'MEDIUM'=>51,'METACAFE'=>52,'MIXCLOUD'=>53,'MSNBC'=>54,'NATGEOCHANNEL'=>55,'NATGEOVIDEO'=>56,'NHL'=>57,'NPR'=>58,'NYTIMES'=>59,'PASTEBIN'=>60,'PODBEAN'=>61,'PREZI'=>62,'RDIO'=>63,'REDDIT'=>64,'RUTUBE'=>65,'SCRIBD'=>66,'SLIDESHARE'=>67,'SOUNDCLOUD'=>68,'SPORTSNET'=>69,'SPOTIFY'=>70,'STITCHER'=>71,'STRAWPOLL'=>72,'STREAMABLE'=>73,'TEAMCOCO'=>74,'TED'=>75,'THEATLANTIC'=>76,'THEONION'=>77,'TINYPIC'=>78,'TMZ'=>79,'TRAILERADDICT'=>80,'TUMBLR'=>81,'TWITCH'=>82,'TWITTER'=>83,'USTREAM'=>84,'VBOX7'=>85,'VEVO'=>86,'VIAGAME'=>87,'VIDEOMEGA'=>88,'VIDME'=>89,'VIMEO'=>90,'VINE'=>91,'VK'=>92,'VOCAROO'=>93,'WSHH'=>94,'WSJ'=>95,'XBOXCLIPS'=>96,'XBOXDVR'=>97,'YAHOOSCREEN'=>98,'YOUKU'=>99,'YOUTUBE'=>100,'ZIPPYSHARE'=>101,'br'=>102,'e'=>103,'i'=>103,'s'=>103,'p'=>104);
	protected static $bt06818E22=array('ca'=>0,'de'=>1,'es'=>2,'fr'=>3,'it'=>4,'jp'=>5,'uk'=>6);
	public function __sleep()
	{
		$props = \get_object_vars($this);
		unset($props['out'], $props['proc'], $props['source']);
		return \array_keys($props);
	}
	public function renderRichText($xml)
	{
		if (!isset($this->quickRenderingTest) || !\preg_match($this->quickRenderingTest, $xml))
			try
			{
				return $this->renderQuick($xml);
			}
			catch (\Exception $e)
			{
			}
		$dom = $this->loadXML($xml);
		$this->out = '';
		$this->at($dom->documentElement);
		return $this->out;
	}
	protected function at(\DOMNode $root)
	{
		if ($root->nodeType === 3)
			$this->out .= \htmlspecialchars($root->textContent,0);
		else
			foreach ($root->childNodes as $node)
				if (!isset(self::$tagBranches[$node->nodeName]))
					$this->at($node);
				else
				{
					$tb = self::$tagBranches[$node->nodeName];
					if($tb<53)if($tb<27)if($tb<14)if($tb<7)if($tb<4){if($tb===0)$this->out.='<iframe width="640" height="360" src="//abcnews.go.com/video/embed?id='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===1){$this->out.='<iframe width="120" height="240" allowfullscreen="" frameborder="0" scrolling="no" src="//rcm';if($node->hasAttribute('tld')&&(\strpos('cadesfritjpuk',$node->getAttribute('tld'))!==\false))$this->out.='-'.\htmlspecialchars($node->getAttribute('tld'),2);$this->out.='.amazon.';if($node->getAttribute('tld')==='jp'||$node->getAttribute('tld')==='uk')$this->out.='co.'.\htmlspecialchars($node->getAttribute('tld'),2);elseif($node->hasAttribute('tld')&&(\strpos('cadesfrit',$node->getAttribute('tld'))!==\false))$this->out.=\htmlspecialchars($node->getAttribute('tld'),2);else$this->out.='com';$this->out.='/e/cm?lt1=_blank&amp;bc1=FFFFFF&amp;bg1=FFFFFF&amp;fc1=000000&amp;lc1=0000FF&amp;p=8&amp;l=as1&amp;f=ifr&amp;asins='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;o=';if(isset(self::$bt06818E22[$node->getAttribute('tld')])){$n=self::$bt06818E22[$node->getAttribute('tld')];if($n<4)if($n===0)$this->out.='15';elseif($n===1)$this->out.='3';elseif($n===2)$this->out.='30';else$this->out.='8';elseif($n===4)$this->out.='29';elseif($n===5)$this->out.='9';else$this->out.='2';}else$this->out.='1';$this->out.='&amp;t=';if($node->getAttribute('tld')==='ca'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_CA']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_CA'],2);elseif($node->getAttribute('tld')==='de'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_DE']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_DE'],2);elseif($node->getAttribute('tld')==='es'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_ES']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_ES'],2);elseif($node->getAttribute('tld')==='fr'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_FR']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_FR'],2);elseif($node->getAttribute('tld')==='it'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_IT']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_IT'],2);elseif($node->getAttribute('tld')==='jp'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_JP']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_JP'],2);elseif($node->getAttribute('tld')==='uk'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_UK']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_UK'],2);elseif(!empty($this->params['AMAZON_ASSOCIATE_TAG']))$this->out.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG'],2);else$this->out.='_';$this->out.='"></iframe>';}elseif($tb===2)$this->out.='<iframe width="100%" height="150" src="//audioboom.com/boos/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed/v3" style="max-width:700px" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else{$this->out.='<iframe width="100%" style="max-width:900px" allowfullscreen="" frameborder="0" scrolling="no" height="';if($node->getAttribute('mode')==='album')$this->out.='340';else$this->out.='110';$this->out.='" src="//www.audiomack.com/embed4';if($node->getAttribute('mode')==='album')$this->out.='-album';$this->out.='/'.\htmlspecialchars($node->getAttribute('id'),2).'"></iframe>';}}elseif($tb===4){$this->out.='<iframe width="400" height="400" allowfullscreen="" frameborder="0" scrolling="no" src="//bandcamp.com/EmbeddedPlayer/size=large/minimal=true/';if($node->hasAttribute('album_id')){$this->out.='album='.\htmlspecialchars($node->getAttribute('album_id'),2);if($node->hasAttribute('track_num'))$this->out.='/t='.\htmlspecialchars($node->getAttribute('track_num'),2);}else$this->out.='track='.\htmlspecialchars($node->getAttribute('track_id'),2);$this->out.='"></iframe>';}elseif($tb===5)$this->out.='<iframe width="560" height="315" src="https://ssl.bbc.co.uk/wwscripts/embed_player#playlist='.\htmlspecialchars($node->getAttribute('playlist'),2).'&amp;poster='.\htmlspecialchars($node->getAttribute('poster'),2).'&amp;ad_site='.\htmlspecialchars($node->getAttribute('ad_site'),2).'&amp;ad_keyword=&amp;source=twitter" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="640" height="360" src="//bleacherreport.com/video_embed?id='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<11)if($tb===7)$this->out.='<iframe width="560" height="315" src="//blip.tv/play/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===8)$this->out.='<iframe width="464" height="280" src="//break.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===9){$this->out.='<object type="application/x-shockwave-flash" typemustmatch="" width="425" height="279" data="';if($node->hasAttribute('pid'))$this->out.='http://www.cbsnews.com/common/video/cbsnews_player.swf';else$this->out.='http://i.i.cbsi.com/cnwk.1d/av/video/cbsnews/atlantis2/cbsnews_player_embed.swf';$this->out.='"><param name="allowfullscreen" value="true"><param name="flashvars" value="';if($node->hasAttribute('pid'))$this->out.='pType=embed&amp;si=254&amp;pid='.\htmlspecialchars($node->getAttribute('pid'),2);else$this->out.='si=254&amp;contentValue='.\htmlspecialchars($node->getAttribute('id'),2);$this->out.='"><embed type="application/x-shockwave-flash" width="425" height="279" allowfullscreen="" src="';if($node->hasAttribute('pid'))$this->out.='http://www.cbsnews.com/common/video/cbsnews_player.swf';else$this->out.='http://i.i.cbsi.com/cnwk.1d/av/video/cbsnews/atlantis2/cbsnews_player_embed.swf';$this->out.='" flashvars="';if($node->hasAttribute('pid'))$this->out.='pType=embed&amp;si=254&amp;pid='.\htmlspecialchars($node->getAttribute('pid'),2);else$this->out.='si=254&amp;contentValue='.\htmlspecialchars($node->getAttribute('id'),2);$this->out.='"></object>';}else$this->out.='<object type="application/x-shockwave-flash" typemustmatch="" width="400" height="380" data="//plus.cnbc.com/rssvideosearch/action/player/id/'.\htmlspecialchars($node->getAttribute('id'),2).'/code/cnbcplayershare"><param name="allowfullscreen" value="true"><embed type="application/x-shockwave-flash" width="400" height="380" src="//plus.cnbc.com/rssvideosearch/action/player/id/'.\htmlspecialchars($node->getAttribute('id'),2).'/code/cnbcplayershare" allowfullscreen=""></object>';elseif($tb===11)$this->out.='<iframe width="560" height="315" src="http://edition.cnn.com/video/api/embed.html#/video/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===12)$this->out.='<iframe width="560" height="360" src="http://money.cnn.com/.element/ssi/video/7.0/players/embed.player.html?videoid=video/'.\htmlspecialchars($node->getAttribute('id'),2).'&amp;width=560&amp;height=360" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="512" height="288" src="//media.mtvnservices.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<21)if($tb<18)if($tb===14)$this->out.='<iframe width="600" height="369" src="//www.collegehumor.com/e/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===15)$this->out.='<iframe width="560" height="315" src="//coub.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===16)$this->out.='<iframe width="560" height="315" src="//www.dailymotion.com/embed/video/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else{$this->out.='<iframe width="640" height="360" allowfullscreen="" frameborder="0" scrolling="no" src="//www.democracynow.org/embed/';if((\strpos($node->getAttribute('id'),'/headlines')!==\false))$this->out.='headlines/'.\htmlspecialchars(\strstr($node->getAttribute('id'),'/headlines',\true),2);elseif((\strpos($node->getAttribute('id'),'2')===0))$this->out.='story/'.\htmlspecialchars($node->getAttribute('id'),2);elseif((\strpos($node->getAttribute('id'),'shows/')===0))$this->out.='show/'.\htmlspecialchars(\substr(\strstr($node->getAttribute('id'),'/'),1),2);else$this->out.=\htmlspecialchars($node->getAttribute('id'),2);$this->out.='"></iframe>';}elseif($tb===18)$this->out.='<iframe width="560" height="315" src="http://www.dumpert.nl/embed/'.\htmlspecialchars(\strtr($node->getAttribute('id'),'_','/'),2).'/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===19)$this->out.='<iframe width="400" height="400" src="//8tracks.com/mixes/'.\htmlspecialchars($node->getAttribute('id'),2).'/player_v3_universal" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="560" height="315" src="https://espn.go.com/video/iframe/twitter/?cms='.\htmlspecialchars($node->getAttribute('cms'),2).'&amp;id='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<24)if($tb===21)$this->out.='<iframe width="560" height="315" src="https://espn.go.com/video/iframe/twitter/?cms=deportes&amp;id='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===22)$this->out.='<iframe width="560" height="315" src="//s9e.github.io/iframe/facebook.min.html#'.\htmlspecialchars($node->getAttribute('id'),2).'" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="500" height="500" src="https://www.flickr.com/photos/_/'.\htmlspecialchars($node->getAttribute('id'),2).'/player/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===24)$this->out.='<iframe width="560" height="315" src="//video.foxnews.com/v/video-embed.html?video_id='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===25)$this->out.='<iframe width="640" height="360" src="http://www.funnyordie.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="640" height="400" src="//www.gamespot.com/videos/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<40){if($tb<34)if($tb<31)if($tb===27)$this->out.='<iframe width="'.\htmlspecialchars($node->getAttribute('width'),2).'" height="'.\htmlspecialchars(49+$node->getAttribute('height'),2).'" src="//embed.gettyimages.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'?et='.\htmlspecialchars($node->getAttribute('et'),2).'&amp;sig='.\htmlspecialchars($node->getAttribute('sig'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===28)$this->out.='<iframe width="'.\htmlspecialchars($node->getAttribute('width'),2).'" height="'.\htmlspecialchars($node->getAttribute('height'),2).'" src="//gfycat.com/iframe/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===29)$this->out.='<iframe width="100%" height="180" src="//s9e.github.io/iframe/gist.min.html#'.\htmlspecialchars($node->getAttribute('id'),2).'" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="560" height="377" src="http://globalnews.ca/video/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===31)$this->out.='<object type="application/x-shockwave-flash" typemustmatch="" width="258" height="338" data="//funds.gofundme.com/Widgetflex.swf"><param name="allowfullscreen" value="true"><param name="flashvars" value="page='.\htmlspecialchars($node->getAttribute('id'),2).'"><embed type="application/x-shockwave-flash" width="258" height="338" src="//funds.gofundme.com/Widgetflex.swf" allowfullscreen="" flashvars="page='.\htmlspecialchars($node->getAttribute('id'),2).'"></object>';elseif($tb===32){$this->out.='<iframe width="450" height="240" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no" src="//s9e.github.io/iframe/googleplus.min.html#';if($node->hasAttribute('oid'))$this->out.=\htmlspecialchars($node->getAttribute('oid'),2);else$this->out.='+'.\htmlspecialchars($node->getAttribute('name'),2);$this->out.='/posts/'.\htmlspecialchars($node->getAttribute('pid'),2).'"></iframe>';}else$this->out.='<iframe width="100%" height="500" style="resize:both" src="https://docs.google.com/spreadsheet/ccc?key='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;widget=true&amp;headers=false&amp;rm=minimal#gid='.\htmlspecialchars($node->getAttribute('gid'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<37)if($tb===34)$this->out.='<iframe width="640" height="360" src="//www.hudl.com/embed/athlete/'.\htmlspecialchars($node->getAttribute('athlete'),2).'/highlights/'.\htmlspecialchars($node->getAttribute('highlight'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===35)$this->out.='<iframe width="640" height="360" src="https://secure.hulu.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="560" height="315" src="http://humortv.vara.nl/embed.'.\htmlspecialchars($node->getAttribute('id'),2).'.html" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===37)$this->out.='<iframe width="468" height="263" src="http://widgets.ign.com/video/embed/content.html?url='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===38)$this->out.='<iframe width="560" height="315" src="http://www.imdb.com/video/imdb/vi'.\htmlspecialchars($node->getAttribute('id'),2).'/imdb/embed?autoplay=false&amp;width=560" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else{$this->out.='<iframe allowfullscreen="" frameborder="0" scrolling="no" width="';if($node->getAttribute('type')==='gifv'&&$node->hasAttribute('width'))$this->out.=\htmlspecialchars($node->getAttribute('width'),2);else$this->out.='100%';$this->out.='" height="';if($node->getAttribute('type')==='gifv'&&$node->hasAttribute('height'))$this->out.=\htmlspecialchars($node->getAttribute('height'),2);else$this->out.='550';$this->out.='" src="';if($node->getAttribute('type')==='gifv')$this->out.='//i.imgur.com/'.\htmlspecialchars($node->getAttribute('id'),2).'.gifv#embed';elseif((\strpos($node->getAttribute('id'),'a/')===0))$this->out.='//imgur.com/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed';elseif($node->getAttribute('type')==='album')$this->out.='//imgur.com/a/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed';else$this->out.='//s9e.github.io/iframe/imgur.min.html#'.\htmlspecialchars($node->getAttribute('id'),2);$this->out.='" onload="';if(!($node->getAttribute('type')==='gifv'||$node->getAttribute('type')==='album'))$this->out.='var id=Math.random();window.addEventListener(\'message\',function(a){a.data.id==id&amp;&amp;(style.height=a.data.height+\'px\',style.width=a.data.width+\'px\')});var origin=src.substr(0,src.indexOf(\'/\',8));contentWindow.postMessage(\'s9e:\'+id,origin);';$this->out.='"></iframe>';}}elseif($tb<47)if($tb<44)if($tb===40)$this->out.='<iframe width="224" height="486" src="//www.indiegogo.com/project/'.\htmlspecialchars($node->getAttribute('id'),2).'/widget" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===41)$this->out.='<iframe width="612" height="710" src="//instagram.com/p/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===42)$this->out.='<iframe width="'.\htmlspecialchars($node->getAttribute('width'),2).'" height="'.\htmlspecialchars($node->getAttribute('height'),2).'" src="https://archive.org/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="560" height="315" src="//www.izlesene.com/embedplayer/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===44)$this->out.='<iframe width="560" height="315" src="//video.khl.ru/iframe/feed/start/'.\htmlspecialchars($node->getAttribute('id'),2).'?type_id=18&amp;width=560&amp;height=315" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===45){$this->out.='<iframe allowfullscreen="" frameborder="0" scrolling="no" width="';if($node->hasAttribute('video'))$this->out.='480';else$this->out.='220';$this->out.='" height="';if($node->hasAttribute('video'))$this->out.='360';else$this->out.='420';$this->out.='" src="//www.kickstarter.com/projects/'.\htmlspecialchars($node->getAttribute('id'),2).'/widget/';if($node->hasAttribute('video'))$this->out.='video';else$this->out.='card';$this->out.='.html"></iframe>';}else$this->out.='<iframe width="640" height="360" src="//www.kissvideo.click/embed.php?vid='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<50){if($tb===47)$this->out.='<iframe width="100%" height="45" style="max-width:900px" src="//html5-player.libsyn.com/embed/episode/id/'.\htmlspecialchars($node->getAttribute('id'),2).'/height/45/width/900/theme/standard/direction/no/autoplay/no/autonext/no/thumbnail/no/preload/no/no_addthis/no/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===48)$this->out.='<iframe width="640" height="360" src="http://www.liveleak.com/ll_embed?i='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else{$this->out.='<iframe width="640" height="360" allowfullscreen="" frameborder="0" scrolling="no" src="//new.livestream.com/accounts/'.\htmlspecialchars($node->getAttribute('account_id'),2).'/events/'.\htmlspecialchars($node->getAttribute('event_id'),2);if($node->hasAttribute('video_id'))$this->out.='/videos/'.\htmlspecialchars($node->getAttribute('video_id'),2);$this->out.='/player?autoPlay=false"></iframe>';}}elseif($tb===50)$this->out.='<iframe width="560" height="342" src="http://videoapi.my.mail.ru/videos/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'.html" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===51)$this->out.='<iframe width="400" height="454" src="https://api.medium.com/embed?type=story&amp;path=//'.\htmlspecialchars($node->getAttribute('id'),2).'" style="border:solid 1px;border-color:#eee #ddd #bbb;border-radius:5px;box-shadow:rgba(0,0,0,0.15) 0px 1px 3px" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="560" height="315" src="//www.metacafe.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<79)if($tb<66)if($tb<60)if($tb<57)if($tb===53)$this->out.='<iframe width="400" height="400" src="//www.mixcloud.com/widget/iframe/?feed=http%3A%2F%2Fwww.mixcloud.com%2F'.\htmlspecialchars($node->getAttribute('id'),2).'%2F&amp;embed_type=widget_standard" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===54)$this->out.='<iframe width="635" height="440" src="//player.theplatform.com/p/2E2eJC/EmbeddedOffSite?guid='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===55)$this->out.='<iframe width="560" height="315" src="//channel.nationalgeographic.com/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="560" height="315" src="//player.d.nationalgeographic.com/players/ngsvideo/share/?guid='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===57)$this->out.='<iframe width="640" height="395" src="//video.nhl.com/videocenter/embed?playlist='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===58)$this->out.='<iframe width="100%" height="228" style="max-width:800px" src="//www.npr.org/player/embed/'.\htmlspecialchars($node->getAttribute('i'),2).'/'.\htmlspecialchars($node->getAttribute('m'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="480" height="373" src="http://graphics8.nytimes.com/bcvideo/1.0/iframe/embed.html?videoId='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;playerType=embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<63)if($tb===60)$this->out.='<iframe width="100%" height="300" src="//pastebin.com/embed_iframe.php?i='.\htmlspecialchars($node->getAttribute('id'),2).'" scrolling="" style="resize:both" allowfullscreen="" frameborder="0"></iframe>';elseif($tb===61)$this->out.='<iframe width="100%" height="100" style="max-width:900px" src="//www.podbean.com/media/player/audio/postId/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="550" height="400" src="//prezi.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===63)$this->out.='<iframe width="400" height="400" src="https://rd.io/i/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===64)$this->out.='<iframe width="800" height="165" src="//s9e.github.io/iframe/reddit.min.html#'.\htmlspecialchars($node->getAttribute('path'),2).'" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="720" height="405" src="//rutube.ru/play/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<73)if($tb<70)if($tb===66)$this->out.='<iframe width="100%" height="500" style="resize:both" src="//www.scribd.com/embeds/'.\htmlspecialchars($node->getAttribute('id'),2).'/content?view_mode=scroll&amp;show_recommendations=false" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===67)$this->out.='<iframe width="427" height="356" src="//www.slideshare.net/slideshow/embed_code/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===68){$this->out.='<iframe width="100%" style="max-width:900px" allowfullscreen="" frameborder="0" scrolling="no" height="';if($node->hasAttribute('playlist_id'))$this->out.='450';else$this->out.='166';$this->out.='" src="https://w.soundcloud.com/player/?url=';if($node->hasAttribute('playlist_id'))$this->out.='https%3A//api.soundcloud.com/playlists/'.\htmlspecialchars($node->getAttribute('playlist_id'),2);elseif($node->hasAttribute('track_id'))$this->out.='https%3A//api.soundcloud.com/tracks/'.\htmlspecialchars($node->getAttribute('track_id'),2);else{if((\strpos($node->getAttribute('id'),'://')===\false))$this->out.='https%3A//soundcloud.com/';$this->out.=\htmlspecialchars($node->getAttribute('id'),2);}$this->out.='"></iframe>';}else$this->out.='<iframe width="560" height="315" src="https://images.rogersdigitalmedia.com/video_service.php?videoId='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;playerKey=AQ~~,AAAAAGWRwLc~,cRCmKE8Utf7OFWP38XQcokFZ80fR-u_y&amp;autoStart=false&amp;width=100%25&amp;height=100%25" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===70){$this->out.='<iframe width="400" height="480" allowfullscreen="" frameborder="0" scrolling="no" src="https://embed.spotify.com/?view=coverart&amp;uri=';if($node->hasAttribute('uri'))$this->out.=\htmlspecialchars($node->getAttribute('uri'),2);else$this->out.='spotify:'.\htmlspecialchars(\strtr($node->getAttribute('path'),'/',':'),2);$this->out.='"></iframe>';}elseif($tb===71)$this->out.='<iframe width="100%" height="150" style="max-width:900px" src="//app.stitcher.com/splayer/f/'.\htmlspecialchars($node->getAttribute('fid'),2).'/'.\htmlspecialchars($node->getAttribute('eid'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="600" height="310" src="http://strawpoll.me/embed_1/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<76){if($tb===73)$this->out.='<iframe width="560" height="315" src="//streamable.com/e/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===74)$this->out.='<iframe width="640" height="415" src="//teamcoco.com/embed/v/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else{$this->out.='<iframe width="560" height="315" allowfullscreen="" frameborder="0" scrolling="no" src="//embed.ted.com/'.\htmlspecialchars($node->getAttribute('id'),2);if((\strpos($node->getAttribute('id'),'.html')===\false))$this->out.='.html';$this->out.='"></iframe>';}}elseif($tb===76)$this->out.='<iframe width="640" height="360" src="http://www.theatlantic.com/video/iframe/'.\htmlspecialchars($node->getAttribute('id'),2).'/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===77)$this->out.='<iframe width="560" height="315" src="http://www.theonion.com/video_embed/?id='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<object type="application/x-shockwave-flash" typemustmatch="" width="560" height="345" data="http://tinypic.com/player.swf?file='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;s='.\htmlspecialchars($node->getAttribute('s'),2).'"><param name="allowfullscreen" value="true"><embed type="application/x-shockwave-flash" width="560" height="345" src="http://tinypic.com/player.swf?file='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;s='.\htmlspecialchars($node->getAttribute('s'),2).'" allowfullscreen=""></object>';elseif($tb<92)if($tb<86)if($tb<83){if($tb===79)$this->out.='<iframe width="560" height="315" src="//www.kaltura.com/index.php/kwidget/cache_st/133592691/wid/_591531/partner_id/591531/uiconf_id/9071262/entry_id/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===80)$this->out.='<iframe width="560" height="315" src="//v.traileraddict.com/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===81)$this->out.='<iframe width="520" height="180" src="//s9e.github.io/iframe/tumblr.min.html#'.\htmlspecialchars($node->getAttribute('key'),2).'/'.\htmlspecialchars($node->getAttribute('id'),2).'" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else{$this->out.='<iframe width="620" height="378" allowfullscreen="" frameborder="0" scrolling="no" src="//s9e.github.io/iframe/twitch.min.html#channel='.\htmlspecialchars($node->getAttribute('channel'),2);if($node->hasAttribute('archive_id'))$this->out.='&amp;videoId=a'.\htmlspecialchars($node->getAttribute('archive_id'),2);elseif($node->hasAttribute('chapter_id'))$this->out.='&amp;videoId=c'.\htmlspecialchars($node->getAttribute('chapter_id'),2);elseif($node->hasAttribute('video_id'))$this->out.='&amp;videoId=v'.\htmlspecialchars($node->getAttribute('video_id'),2);$this->out.='"></iframe>';}}elseif($tb===83)$this->out.='<iframe width="500" height="186" src="//s9e.github.io/iframe/twitter.min.html#'.\htmlspecialchars($node->getAttribute('id'),2).'" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===84){$this->out.='<iframe width="480" height="302" allowfullscreen="" frameborder="0" scrolling="no" src="//www.ustream.tv/embed/';if($node->hasAttribute('vid'))$this->out.='recorded/'.\htmlspecialchars($node->getAttribute('vid'),2);else$this->out.=\htmlspecialchars($node->getAttribute('cid'),2);$this->out.='"></iframe>';}else$this->out.='<iframe width="560" height="315" src="http://vbox7.com/emb/external.php?vid='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<89)if($tb===86)$this->out.='<iframe width="575" height="324" src="http://cache.vevo.com/m/html/embed.html?video='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===87)$this->out.='<iframe width="640" height="392" src="//www.viagame.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="560" height="315" src="http://videomega.tv/iframe.php?ref='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===89)$this->out.='<iframe width="'.\htmlspecialchars($node->getAttribute('width'),2).'" height="'.\htmlspecialchars($node->getAttribute('height'),2).'" src="https://vid.me/e/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===90)$this->out.='<iframe width="560" height="315" src="//player.vimeo.com/video/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="480" height="480" src="https://vine.co/v/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed/simple" allowfullscreen="" frameborder="0" scrolling="no"></iframe><script async="" src="//platform.vine.co/static/scripts/embed.js" charset="utf-8"></script>';elseif($tb<99)if($tb<96)if($tb===92)$this->out.='<iframe width="607" height="360" src="//vk.com/video_ext.php?oid='.\htmlspecialchars($node->getAttribute('oid'),2).'&amp;id='.\htmlspecialchars($node->getAttribute('vid'),2).'&amp;hash='.\htmlspecialchars($node->getAttribute('hash'),2).'&amp;hd=1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===93)$this->out.='<object type="application/x-shockwave-flash" typemustmatch="" width="148" height="44" data="//vocaroo.com/player.swf?playMediaID='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;autoplay=0"><param name="allowfullscreen" value="true"><embed type="application/x-shockwave-flash" width="148" height="44" src="//vocaroo.com/player.swf?playMediaID='.\htmlspecialchars($node->getAttribute('id'),2).'&amp;autoplay=0" allowfullscreen=""></object>';elseif($tb===94)$this->out.='<iframe width="640" height="360" src="//www.worldstarhiphop.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="512" height="288" src="//video-api.wsj.com/api-video/player/iframe.html?guid='.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===96)$this->out.='<iframe width="560" height="315" src="//xboxclips.com/'.\htmlspecialchars($node->getAttribute('user'),2).'/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===97)$this->out.='<iframe width="560" height="430" src="//xboxdvr.com/'.\htmlspecialchars($node->getAttribute('user'),2).'/'.\htmlspecialchars($node->getAttribute('id'),2).'/embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';else$this->out.='<iframe width="640" height="360" src="https://screen.yahoo.com/'.\htmlspecialchars($node->getAttribute('id'),2).'.html?format=embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb<102)if($tb===99)$this->out.='<iframe width="512" height="328" src="http://player.youku.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2).'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';elseif($tb===100){$this->out.='<iframe width="560" height="315" allowfullscreen="" frameborder="0" scrolling="no" src="//www.youtube.com/embed/'.\htmlspecialchars($node->getAttribute('id'),2);if($node->hasAttribute('list'))$this->out.='?list='.\htmlspecialchars($node->getAttribute('list'),2);if($node->hasAttribute('t')||$node->hasAttribute('m')){if($node->hasAttribute('list'))$this->out.='&amp;';else$this->out.='?';$this->out.='start=';if($node->hasAttribute('t'))$this->out.=\htmlspecialchars($node->getAttribute('t'),2);elseif($node->hasAttribute('h'))$this->out.=\htmlspecialchars($node->getAttribute('h')*3600+$node->getAttribute('m')*60+$node->getAttribute('s'),2);else$this->out.=\htmlspecialchars($node->getAttribute('m')*60+$node->getAttribute('s'),2);}$this->out.='"></iframe>';}else$this->out.='<object type="application/x-shockwave-flash" typemustmatch="" width="100%" height="80" data="//api.zippyshare.com/api/player.swf" style="max-width:900px"><param name="allowfullscreen" value="true"><param name="flashvars" value="file='.\htmlspecialchars($node->getAttribute('file'),2).'&amp;server='.\htmlspecialchars($node->getAttribute('server'),2).'&amp;autostart=false"><embed type="application/x-shockwave-flash" width="100%" height="80" style="max-width:900px" src="//api.zippyshare.com/api/player.swf" allowfullscreen="" flashvars="file='.\htmlspecialchars($node->getAttribute('file'),2).'&amp;server='.\htmlspecialchars($node->getAttribute('server'),2).'&amp;autostart=false"></object>';elseif($tb===102)$this->out.='<br>';elseif($tb===103);else{$this->out.='<p>';$this->at($node);$this->out.='</p>';}
				}
	}
	private static $dynamic=array('ABCNEWS'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="//abcnews.go.com/video/embed?id=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'AUDIOBOOM'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="100%" height="150" src="//audioboom.com/boos/$1/embed/v3" style="max-width:700px" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'BBCNEWS'=>array('(^[^ ]+(?> (?!(?>ad_site|p(?>laylist|oster))=)[^=]+="[^"]*")*(?> ad_site="([^"]*)")?(?> (?!p(?>laylist|oster)=)[^=]+="[^"]*")*(?> playlist="([^"]*)")?(?> (?!poster=)[^=]+="[^"]*")*(?> poster="([^"]*)")?.*)s','<iframe width="560" height="315" src="https://ssl.bbc.co.uk/wwscripts/embed_player#playlist=$2&amp;poster=$3&amp;ad_site=$1&amp;ad_keyword=&amp;source=twitter" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'BLEACHERREPORT'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="//bleacherreport.com/video_embed?id=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'BLIP'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//blip.tv/play/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'BREAK'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="464" height="280" src="//break.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'CNBC'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<object type="application/x-shockwave-flash" typemustmatch="" width="400" height="380" data="//plus.cnbc.com/rssvideosearch/action/player/id/$1/code/cnbcplayershare"><param name="allowfullscreen" value="true"><embed type="application/x-shockwave-flash" width="400" height="380" src="//plus.cnbc.com/rssvideosearch/action/player/id/$1/code/cnbcplayershare" allowfullscreen=""></object>'),'CNN'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="http://edition.cnn.com/video/api/embed.html#/video/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'CNNMONEY'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="360" src="http://money.cnn.com/.element/ssi/video/7.0/players/embed.player.html?videoid=video/$1&amp;width=560&amp;height=360" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'COLBERTNATION'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="512" height="288" src="//media.mtvnservices.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'COLLEGEHUMOR'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="600" height="369" src="//www.collegehumor.com/e/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'COMEDYCENTRAL'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="512" height="288" src="//media.mtvnservices.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'COUB'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//coub.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'DAILYMOTION'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//www.dailymotion.com/embed/video/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'DAILYSHOW'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="512" height="288" src="//media.mtvnservices.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'EIGHTTRACKS'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="400" height="400" src="//8tracks.com/mixes/$1/player_v3_universal" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'ESPN'=>array('(^[^ ]+(?> (?!(?>cms|id)=)[^=]+="[^"]*")*(?> cms="([^"]*)")?(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="https://espn.go.com/video/iframe/twitter/?cms=$1&amp;id=$2" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'ESPNDEPORTES'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="https://espn.go.com/video/iframe/twitter/?cms=deportes&amp;id=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'FACEBOOK'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//s9e.github.io/iframe/facebook.min.html#$1" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'FLICKR'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="500" height="500" src="https://www.flickr.com/photos/_/$1/player/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'FOXNEWS'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//video.foxnews.com/v/video-embed.html?video_id=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'FUNNYORDIE'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="http://www.funnyordie.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'GAMESPOT'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="400" src="//www.gamespot.com/videos/embed/$1/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'GAMETRAILERS'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="512" height="288" src="//media.mtvnservices.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'GFYCAT'=>array('(^[^ ]+(?> (?!(?>height|id|width)=)[^=]+="[^"]*")*(?> height="([^"]*)")?(?> (?!(?>id|width)=)[^=]+="[^"]*")*(?> id="([^"]*)")?(?> (?!width=)[^=]+="[^"]*")*(?> width="([^"]*)")?.*)s','<iframe width="$3" height="$1" src="//gfycat.com/iframe/$2" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'GIST'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="100%" height="180" src="//s9e.github.io/iframe/gist.min.html#$1" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'GLOBALNEWS'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="377" src="http://globalnews.ca/video/embed/$1/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'GOFUNDME'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<object type="application/x-shockwave-flash" typemustmatch="" width="258" height="338" data="//funds.gofundme.com/Widgetflex.swf"><param name="allowfullscreen" value="true"><param name="flashvars" value="page=$1"><embed type="application/x-shockwave-flash" width="258" height="338" src="//funds.gofundme.com/Widgetflex.swf" allowfullscreen="" flashvars="page=$1"></object>'),'GOOGLESHEETS'=>array('(^[^ ]+(?> (?!g?id=)[^=]+="[^"]*")*(?> gid="([^"]*)")?(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="100%" height="500" style="resize:both" src="https://docs.google.com/spreadsheet/ccc?key=$2&amp;widget=true&amp;headers=false&amp;rm=minimal#gid=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'HUDL'=>array('(^[^ ]+(?> (?!(?>athlete|highlight)=)[^=]+="[^"]*")*(?> athlete="([^"]*)")?(?> (?!highlight=)[^=]+="[^"]*")*(?> highlight="([^"]*)")?.*)s','<iframe width="640" height="360" src="//www.hudl.com/embed/athlete/$1/highlights/$2" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'HULU'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="https://secure.hulu.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'HUMORTVNL'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="http://humortv.vara.nl/embed.$1.html" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'IGN'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="468" height="263" src="http://widgets.ign.com/video/embed/content.html?url=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'IMDB'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="http://www.imdb.com/video/imdb/vi$1/imdb/embed?autoplay=false&amp;width=560" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'INDIEGOGO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="224" height="486" src="//www.indiegogo.com/project/$1/widget" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'INSTAGRAM'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="612" height="710" src="//instagram.com/p/$1/embed/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'INTERNETARCHIVE'=>array('(^[^ ]+(?> (?!(?>height|id|width)=)[^=]+="[^"]*")*(?> height="([^"]*)")?(?> (?!(?>id|width)=)[^=]+="[^"]*")*(?> id="([^"]*)")?(?> (?!width=)[^=]+="[^"]*")*(?> width="([^"]*)")?.*)s','<iframe width="$3" height="$1" src="https://archive.org/embed/$2" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'IZLESENE'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//www.izlesene.com/embedplayer/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'KHL'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//video.khl.ru/iframe/feed/start/$1?type_id=18&amp;width=560&amp;height=315" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'KISSVIDEO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="//www.kissvideo.click/embed.php?vid=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'LIBSYN'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="100%" height="45" style="max-width:900px" src="//html5-player.libsyn.com/embed/episode/id/$1/height/45/width/900/theme/standard/direction/no/autoplay/no/autonext/no/thumbnail/no/preload/no/no_addthis/no/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'LIVELEAK'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="http://www.liveleak.com/ll_embed?i=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'MAILRU'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="342" src="http://videoapi.my.mail.ru/videos/embed/$1.html" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'MEDIUM'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="400" height="454" src="https://api.medium.com/embed?type=story&amp;path=//$1" style="border:solid 1px;border-color:#eee #ddd #bbb;border-radius:5px;box-shadow:rgba(0,0,0,0.15) 0px 1px 3px" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'METACAFE'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//www.metacafe.com/embed/$1/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'MIXCLOUD'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="400" height="400" src="//www.mixcloud.com/widget/iframe/?feed=http%3A%2F%2Fwww.mixcloud.com%2F$1%2F&amp;embed_type=widget_standard" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'MSNBC'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="635" height="440" src="//player.theplatform.com/p/2E2eJC/EmbeddedOffSite?guid=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'NATGEOCHANNEL'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//channel.nationalgeographic.com/$1/embed/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'NATGEOVIDEO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//player.d.nationalgeographic.com/players/ngsvideo/share/?guid=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'NHL'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="395" src="//video.nhl.com/videocenter/embed?playlist=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'NPR'=>array('(^[^ ]+(?> (?![im]=)[^=]+="[^"]*")*(?> i="([^"]*)")?(?> (?!m=)[^=]+="[^"]*")*(?> m="([^"]*)")?.*)s','<iframe width="100%" height="228" style="max-width:800px" src="//www.npr.org/player/embed/$1/$2" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'NYTIMES'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="480" height="373" src="http://graphics8.nytimes.com/bcvideo/1.0/iframe/embed.html?videoId=$1&amp;playerType=embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'PASTEBIN'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="100%" height="300" src="//pastebin.com/embed_iframe.php?i=$1" scrolling="" style="resize:both" allowfullscreen="" frameborder="0"></iframe>'),'PODBEAN'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="100%" height="100" style="max-width:900px" src="//www.podbean.com/media/player/audio/postId/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'PREZI'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="550" height="400" src="//prezi.com/embed/$1/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'RDIO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="400" height="400" src="https://rd.io/i/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'REDDIT'=>array('(^[^ ]+(?> (?!path=)[^=]+="[^"]*")*(?> path="([^"]*)")?.*)s','<iframe width="800" height="165" src="//s9e.github.io/iframe/reddit.min.html#$1" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'RUTUBE'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="720" height="405" src="//rutube.ru/play/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'SCRIBD'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="100%" height="500" style="resize:both" src="//www.scribd.com/embeds/$1/content?view_mode=scroll&amp;show_recommendations=false" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'SLIDESHARE'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="427" height="356" src="//www.slideshare.net/slideshow/embed_code/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'SPORTSNET'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="https://images.rogersdigitalmedia.com/video_service.php?videoId=$1&amp;playerKey=AQ~~,AAAAAGWRwLc~,cRCmKE8Utf7OFWP38XQcokFZ80fR-u_y&amp;autoStart=false&amp;width=100%25&amp;height=100%25" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'STITCHER'=>array('(^[^ ]+(?> (?![ef]id=)[^=]+="[^"]*")*(?> eid="([^"]*)")?(?> (?!fid=)[^=]+="[^"]*")*(?> fid="([^"]*)")?.*)s','<iframe width="100%" height="150" style="max-width:900px" src="//app.stitcher.com/splayer/f/$2/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'STRAWPOLL'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="600" height="310" src="http://strawpoll.me/embed_1/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'STREAMABLE'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//streamable.com/e/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'TEAMCOCO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="415" src="//teamcoco.com/embed/v/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'THEATLANTIC'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="http://www.theatlantic.com/video/iframe/$1/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'THEONION'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="http://www.theonion.com/video_embed/?id=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'TINYPIC'=>array('(^[^ ]+(?> (?!(?>s|id)=)[^=]+="[^"]*")*(?> id="([^"]*)")?(?> (?!s=)[^=]+="[^"]*")*(?> s="([^"]*)")?.*)s','<object type="application/x-shockwave-flash" typemustmatch="" width="560" height="345" data="http://tinypic.com/player.swf?file=$1&amp;s=$2"><param name="allowfullscreen" value="true"><embed type="application/x-shockwave-flash" width="560" height="345" src="http://tinypic.com/player.swf?file=$1&amp;s=$2" allowfullscreen=""></object>'),'TMZ'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//www.kaltura.com/index.php/kwidget/cache_st/133592691/wid/_591531/partner_id/591531/uiconf_id/9071262/entry_id/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'TRAILERADDICT'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//v.traileraddict.com/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'TUMBLR'=>array('(^[^ ]+(?> (?!(?>id|key)=)[^=]+="[^"]*")*(?> id="([^"]*)")?(?> (?!key=)[^=]+="[^"]*")*(?> key="([^"]*)")?.*)s','<iframe width="520" height="180" src="//s9e.github.io/iframe/tumblr.min.html#$2/$1" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'TWITTER'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="500" height="186" src="//s9e.github.io/iframe/twitter.min.html#$1" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VBOX7'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="http://vbox7.com/emb/external.php?vid=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VEVO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="575" height="324" src="http://cache.vevo.com/m/html/embed.html?video=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VIAGAME'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="392" src="//www.viagame.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VIDEOMEGA'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="http://videomega.tv/iframe.php?ref=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VIDME'=>array('(^[^ ]+(?> (?!(?>height|id|width)=)[^=]+="[^"]*")*(?> height="([^"]*)")?(?> (?!(?>id|width)=)[^=]+="[^"]*")*(?> id="([^"]*)")?(?> (?!width=)[^=]+="[^"]*")*(?> width="([^"]*)")?.*)s','<iframe width="$3" height="$1" src="https://vid.me/e/$2" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VIMEO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="560" height="315" src="//player.vimeo.com/video/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VINE'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="480" height="480" src="https://vine.co/v/$1/embed/simple" allowfullscreen="" frameborder="0" scrolling="no"></iframe><script async="" src="//platform.vine.co/static/scripts/embed.js" charset="utf-8"></script>'),'VK'=>array('(^[^ ]+(?> (?!(?>hash|oid|vid)=)[^=]+="[^"]*")*(?> hash="([^"]*)")?(?> (?![ov]id=)[^=]+="[^"]*")*(?> oid="([^"]*)")?(?> (?!vid=)[^=]+="[^"]*")*(?> vid="([^"]*)")?.*)s','<iframe width="607" height="360" src="//vk.com/video_ext.php?oid=$2&amp;id=$3&amp;hash=$1&amp;hd=1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'VOCAROO'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<object type="application/x-shockwave-flash" typemustmatch="" width="148" height="44" data="//vocaroo.com/player.swf?playMediaID=$1&amp;autoplay=0"><param name="allowfullscreen" value="true"><embed type="application/x-shockwave-flash" width="148" height="44" src="//vocaroo.com/player.swf?playMediaID=$1&amp;autoplay=0" allowfullscreen=""></object>'),'WSHH'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="//www.worldstarhiphop.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'WSJ'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="512" height="288" src="//video-api.wsj.com/api-video/player/iframe.html?guid=$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'XBOXCLIPS'=>array('(^[^ ]+(?> (?!(?>id|user)=)[^=]+="[^"]*")*(?> id="([^"]*)")?(?> (?!user=)[^=]+="[^"]*")*(?> user="([^"]*)")?.*)s','<iframe width="560" height="315" src="//xboxclips.com/$2/$1/embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'XBOXDVR'=>array('(^[^ ]+(?> (?!(?>id|user)=)[^=]+="[^"]*")*(?> id="([^"]*)")?(?> (?!user=)[^=]+="[^"]*")*(?> user="([^"]*)")?.*)s','<iframe width="560" height="430" src="//xboxdvr.com/$2/$1/embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'YAHOOSCREEN'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="640" height="360" src="https://screen.yahoo.com/$1.html?format=embed" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'YOUKU'=>array('(^[^ ]+(?> (?!id=)[^=]+="[^"]*")*(?> id="([^"]*)")?.*)s','<iframe width="512" height="328" src="http://player.youku.com/embed/$1" allowfullscreen="" frameborder="0" scrolling="no"></iframe>'),'ZIPPYSHARE'=>array('(^[^ ]+(?> (?!(?>file|server)=)[^=]+="[^"]*")*(?> file="([^"]*)")?(?> (?!server=)[^=]+="[^"]*")*(?> server="([^"]*)")?.*)s','<object type="application/x-shockwave-flash" typemustmatch="" width="100%" height="80" data="//api.zippyshare.com/api/player.swf" style="max-width:900px"><param name="allowfullscreen" value="true"><param name="flashvars" value="file=$1&amp;server=$2&amp;autostart=false"><embed type="application/x-shockwave-flash" width="100%" height="80" style="max-width:900px" src="//api.zippyshare.com/api/player.swf" allowfullscreen="" flashvars="file=$1&amp;server=$2&amp;autostart=false"></object>'));
	private static $attributes;
	private static $quickBranches=array('AMAZON'=>0,'AUDIOMACK'=>1,'BANDCAMP'=>2,'CBSNEWS'=>3,'DEMOCRACYNOW'=>4,'DUMPERT'=>5,'GETTY'=>6,'GOOGLEPLUS'=>7,'IMGUR'=>8,'KICKSTARTER'=>9,'LIVESTREAM'=>10,'SOUNDCLOUD'=>11,'SPOTIFY'=>12,'TED'=>13,'TWITCH'=>14,'USTREAM'=>15,'YOUTUBE'=>16);
	protected function renderQuick($xml)
	{
		$xml = $this->decodeSMP($xml);
		self::$attributes = array();
		$html = \preg_replace_callback(
			'(<(?:(?!/)((?:A(?>BCNEWS|MAZON|UDIO(?>BOOM|MACK))|B(?>ANDCAMP|BCNEWS|L(?>EACHERREPORT|IP)|REAK)|C(?:BSNEWS|N(?:BC|N(?>MONEY)?)|O(?>L(?>BERTNATION|LEGEHUMOR)|MEDYCENTRAL|UB))|D(?>AILY(?>MOTION|SHOW)|EMOCRACYNOW|UMPERT)|E(?:IGHTTRACKS|SPN(?>DEPORTES)?)|F(?>ACEBOOK|LICKR|OXNEWS|UNNYORDIE)|G(?>AME(?>SPOT|TRAILERS)|ETTY|FYCAT|IST|LOBALNEWS|O(?>FUNDME|OGLE(?>PLU|SHEET)S))|HU(?>DL|LU|MORTVNL)|I(?>GN|M(?>DB|GUR)|N(?>DIEGOGO|STAGRAM|TERNETARCHIVE)|ZLESENE)|K(?>HL|I(?>CKSTARTER|SSVIDEO))|LI(?>BSYN|VE(?>LEAK|STREAM))|M(?>AILRU|E(?>DIUM|TACAFE)|IXCLOUD|SNBC)|N(?>ATGEO(?>CHANNEL|VIDEO)|HL|PR|YTIMES)|P(?>ASTEBIN|ODBEAN|REZI)|R(?>DIO|EDDIT|UTUBE)|S(?>CRIBD|LIDESHARE|OUNDCLOUD|PO(?>RTSNET|TIFY)|T(?>ITCHER|R(?>AWPOLL|EAMABLE)))|T(?>E(?>D|AMCOCO)|HE(?>ATLANTIC|ONION)|INYPIC|MZ|RAILERADDICT|UMBLR|WIT(?>CH|TER))|USTREAM|V(?>K|BOX7|EVO|I(?>AGAME|D(?>EOMEGA|ME)|MEO|NE)|OCAROO)|WS(?>J|HH)|XBOX(?>CLIPS|DVR)|Y(?>AHOOSCREEN|OU(?>KU|TUBE))|ZIPPYSHARE))(?: [^>]*)?>.*?</\\1|(/?(?!br/|p>)[^ />]+)[^>]*?(/)?)>)',
			array($this, 'quick'),
			\preg_replace(
				'(<[eis]>[^<]*</[eis]>)',
				'',
				\substr($xml, 1 + \strpos($xml, '>'), -4)
			)
		);
		return \str_replace('<br/>', '<br>', $html);
	}
	protected function quick($m)
	{
		if (isset($m[2]))
		{
			$id = $m[2];
			if (isset($m[3]))
			{
				unset($m[3]);
				$m[0] = \substr($m[0], 0, -2) . '>';
				$html = $this->quick($m);
				$m[0] = '</' . $id . '>';
				$m[2] = '/' . $id;
				$html .= $this->quick($m);
				return $html;
			}
		}
		else
		{
			$id = $m[1];
			$lpos = 1 + \strpos($m[0], '>');
			$rpos = \strrpos($m[0], '<');
			$textContent = \substr($m[0], $lpos, $rpos - $lpos);
			if (\strpos($textContent, '<') !== \false)
				throw new \RuntimeException;
			$textContent = \htmlspecialchars_decode($textContent);
		}
		if (isset(self::$dynamic[$id]))
		{
			list($match, $replace) = self::$dynamic[$id];
			return \preg_replace($match, $replace, $m[0], 1, $cnt);
		}
		if (!isset(self::$quickBranches[$id]))
		{
			if ($id[0] === '!' || $id[0] === '?')
				throw new \RuntimeException;
			return '';
		}
		$attributes = array();
		if (\strpos($m[0], '="') !== \false)
		{
			\preg_match_all('(([^ =]++)="([^"]*))S', \substr($m[0], 0, \strpos($m[0], '>')), $matches);
			foreach ($matches[1] as $i => $attrName)
				$attributes[$attrName] = $matches[2][$i];
		}
		$qb = self::$quickBranches[$id];
		if($qb<9){if($qb<5)if($qb<3)if($qb===0){$attributes+=array('tld'=>\null,'id'=>\null);$html='<iframe width="120" height="240" allowfullscreen="" frameborder="0" scrolling="no" src="//rcm';if(isset($attributes['tld'])&&(\strpos('cadesfritjpuk',$attributes['tld'])!==\false))$html.='-'.$attributes['tld'];$html.='.amazon.';if($attributes['tld']==='jp'||$attributes['tld']==='uk')$html.='co.'.$attributes['tld'];elseif(isset($attributes['tld'])&&(\strpos('cadesfrit',$attributes['tld'])!==\false))$html.=$attributes['tld'];else$html.='com';$html.='/e/cm?lt1=_blank&amp;bc1=FFFFFF&amp;bg1=FFFFFF&amp;fc1=000000&amp;lc1=0000FF&amp;p=8&amp;l=as1&amp;f=ifr&amp;asins='.$attributes['id'].'&amp;o=';if(isset(self::$bt06818E22[\htmlspecialchars_decode($attributes['tld'])])){$n=self::$bt06818E22[\htmlspecialchars_decode($attributes['tld'])];if($n<4)if($n===0)$html.='15';elseif($n===1)$html.='3';elseif($n===2)$html.='30';else$html.='8';elseif($n===4)$html.='29';elseif($n===5)$html.='9';else$html.='2';}else$html.='1';$html.='&amp;t=';if($attributes['tld']==='ca'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_CA']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_CA'],2);elseif($attributes['tld']==='de'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_DE']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_DE'],2);elseif($attributes['tld']==='es'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_ES']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_ES'],2);elseif($attributes['tld']==='fr'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_FR']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_FR'],2);elseif($attributes['tld']==='it'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_IT']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_IT'],2);elseif($attributes['tld']==='jp'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_JP']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_JP'],2);elseif($attributes['tld']==='uk'&&!empty($this->params['AMAZON_ASSOCIATE_TAG_UK']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG_UK'],2);elseif(!empty($this->params['AMAZON_ASSOCIATE_TAG']))$html.=\htmlspecialchars($this->params['AMAZON_ASSOCIATE_TAG'],2);else$html.='_';$html.='"></iframe>';}elseif($qb===1){$attributes+=array('mode'=>\null,'id'=>\null);$html='<iframe width="100%" style="max-width:900px" allowfullscreen="" frameborder="0" scrolling="no" height="';if($attributes['mode']==='album')$html.='340';else$html.='110';$html.='" src="//www.audiomack.com/embed4';if($attributes['mode']==='album')$html.='-album';$html.='/'.$attributes['id'].'"></iframe>';}else{$attributes+=array('track_num'=>\null,'track_id'=>\null);$html='<iframe width="400" height="400" allowfullscreen="" frameborder="0" scrolling="no" src="//bandcamp.com/EmbeddedPlayer/size=large/minimal=true/';if(isset($attributes['album_id'])){$html.='album='.$attributes['album_id'];if(isset($attributes['track_num']))$html.='/t='.$attributes['track_num'];}else$html.='track='.$attributes['track_id'];$html.='"></iframe>';}elseif($qb===3){$attributes+=array('id'=>\null);$html='<object type="application/x-shockwave-flash" typemustmatch="" width="425" height="279" data="';if(isset($attributes['pid']))$html.='http://www.cbsnews.com/common/video/cbsnews_player.swf';else$html.='http://i.i.cbsi.com/cnwk.1d/av/video/cbsnews/atlantis2/cbsnews_player_embed.swf';$html.='"><param name="allowfullscreen" value="true"><param name="flashvars" value="';if(isset($attributes['pid']))$html.='pType=embed&amp;si=254&amp;pid='.$attributes['pid'];else$html.='si=254&amp;contentValue='.$attributes['id'];$html.='"><embed type="application/x-shockwave-flash" width="425" height="279" allowfullscreen="" src="';if(isset($attributes['pid']))$html.='http://www.cbsnews.com/common/video/cbsnews_player.swf';else$html.='http://i.i.cbsi.com/cnwk.1d/av/video/cbsnews/atlantis2/cbsnews_player_embed.swf';$html.='" flashvars="';if(isset($attributes['pid']))$html.='pType=embed&amp;si=254&amp;pid='.$attributes['pid'];else$html.='si=254&amp;contentValue='.$attributes['id'];$html.='"></object>';}else{$attributes+=array('id'=>\null);$html='<iframe width="640" height="360" allowfullscreen="" frameborder="0" scrolling="no" src="//www.democracynow.org/embed/';if((\strpos($attributes['id'],'/headlines')!==\false))$html.='headlines/'.\htmlspecialchars(\strstr(\htmlspecialchars_decode($attributes['id']),'/headlines',\true),2);elseif((\strpos($attributes['id'],'2')===0))$html.='story/'.$attributes['id'];elseif((\strpos($attributes['id'],'shows/')===0))$html.='show/'.\htmlspecialchars(\substr(\strstr(\htmlspecialchars_decode($attributes['id']),'/'),1),2);else$html.=$attributes['id'];$html.='"></iframe>';}elseif($qb===5){$attributes+=array('id'=>\null);$html='<iframe width="560" height="315" src="http://www.dumpert.nl/embed/'.\strtr($attributes['id'],'_','/').'/" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';}elseif($qb===6){$attributes+=array('width'=>\null,'height'=>\null,'id'=>\null,'et'=>\null,'sig'=>\null);$html='<iframe width="'.$attributes['width'].'" height="'.\htmlspecialchars(49+$attributes['height'],2).'" src="//embed.gettyimages.com/embed/'.$attributes['id'].'?et='.$attributes['et'].'&amp;sig='.$attributes['sig'].'" allowfullscreen="" frameborder="0" scrolling="no"></iframe>';}elseif($qb===7){$attributes+=array('name'=>\null,'pid'=>\null);$html='<iframe width="450" height="240" onload="var a=Math.random();window.addEventListener(\'message\',function(b){if(b.data.id==a)style.height=b.data.height+\'px\'});contentWindow.postMessage(\'s9e:\'+a,src.substr(0,src.indexOf(\'/\',8)))" allowfullscreen="" frameborder="0" scrolling="no" src="//s9e.github.io/iframe/googleplus.min.html#';if(isset($attributes['oid']))$html.=$attributes['oid'];else$html.='+'.$attributes['name'];$html.='/posts/'.$attributes['pid'].'"></iframe>';}else{$attributes+=array('type'=>\null,'width'=>\null,'height'=>\null,'id'=>\null);$html='<iframe allowfullscreen="" frameborder="0" scrolling="no" width="';if($attributes['type']==='gifv'&&isset($attributes['width']))$html.=$attributes['width'];else$html.='100%';$html.='" height="';if($attributes['type']==='gifv'&&isset($attributes['height']))$html.=$attributes['height'];else$html.='550';$html.='" src="';if($attributes['type']==='gifv')$html.='//i.imgur.com/'.$attributes['id'].'.gifv#embed';elseif((\strpos($attributes['id'],'a/')===0))$html.='//imgur.com/'.$attributes['id'].'/embed';elseif($attributes['type']==='album')$html.='//imgur.com/a/'.$attributes['id'].'/embed';else$html.='//s9e.github.io/iframe/imgur.min.html#'.$attributes['id'];$html.='" onload="';if(!($attributes['type']==='gifv'||$attributes['type']==='album'))$html.='var id=Math.random();window.addEventListener(\'message\',function(a){a.data.id==id&amp;&amp;(style.height=a.data.height+\'px\',style.width=a.data.width+\'px\')});var origin=src.substr(0,src.indexOf(\'/\',8));contentWindow.postMessage(\'s9e:\'+id,origin);';$html.='"></iframe>';}}elseif($qb<13)if($qb===9){$attributes+=array('id'=>\null);$html='<iframe allowfullscreen="" frameborder="0" scrolling="no" width="';if(isset($attributes['video']))$html.='480';else$html.='220';$html.='" height="';if(isset($attributes['video']))$html.='360';else$html.='420';$html.='" src="//www.kickstarter.com/projects/'.$attributes['id'].'/widget/';if(isset($attributes['video']))$html.='video';else$html.='card';$html.='.html"></iframe>';}elseif($qb===10){$attributes+=array('account_id'=>\null,'event_id'=>\null);$html='<iframe width="640" height="360" allowfullscreen="" frameborder="0" scrolling="no" src="//new.livestream.com/accounts/'.$attributes['account_id'].'/events/'.$attributes['event_id'];if(isset($attributes['video_id']))$html.='/videos/'.$attributes['video_id'];$html.='/player?autoPlay=false"></iframe>';}elseif($qb===11){$attributes+=array('id'=>\null);$html='<iframe width="100%" style="max-width:900px" allowfullscreen="" frameborder="0" scrolling="no" height="';if(isset($attributes['playlist_id']))$html.='450';else$html.='166';$html.='" src="https://w.soundcloud.com/player/?url=';if(isset($attributes['playlist_id']))$html.='https%3A//api.soundcloud.com/playlists/'.$attributes['playlist_id'];elseif(isset($attributes['track_id']))$html.='https%3A//api.soundcloud.com/tracks/'.$attributes['track_id'];else{if((\strpos($attributes['id'],'://')===\false))$html.='https%3A//soundcloud.com/';$html.=$attributes['id'];}$html.='"></iframe>';}else{$attributes+=array('path'=>\null);$html='<iframe width="400" height="480" allowfullscreen="" frameborder="0" scrolling="no" src="https://embed.spotify.com/?view=coverart&amp;uri=';if(isset($attributes['uri']))$html.=$attributes['uri'];else$html.='spotify:'.\strtr($attributes['path'],'/',':');$html.='"></iframe>';}elseif($qb===13){$attributes+=array('id'=>\null);$html='<iframe width="560" height="315" allowfullscreen="" frameborder="0" scrolling="no" src="//embed.ted.com/'.$attributes['id'];if((\strpos($attributes['id'],'.html')===\false))$html.='.html';$html.='"></iframe>';}elseif($qb===14){$attributes+=array('channel'=>\null);$html='<iframe width="620" height="378" allowfullscreen="" frameborder="0" scrolling="no" src="//s9e.github.io/iframe/twitch.min.html#channel='.$attributes['channel'];if(isset($attributes['archive_id']))$html.='&amp;videoId=a'.$attributes['archive_id'];elseif(isset($attributes['chapter_id']))$html.='&amp;videoId=c'.$attributes['chapter_id'];elseif(isset($attributes['video_id']))$html.='&amp;videoId=v'.$attributes['video_id'];$html.='"></iframe>';}elseif($qb===15){$attributes+=array('cid'=>\null);$html='<iframe width="480" height="302" allowfullscreen="" frameborder="0" scrolling="no" src="//www.ustream.tv/embed/';if(isset($attributes['vid']))$html.='recorded/'.$attributes['vid'];else$html.=$attributes['cid'];$html.='"></iframe>';}else{$attributes+=array('id'=>\null,'m'=>\null,'s'=>\null);$html='<iframe width="560" height="315" allowfullscreen="" frameborder="0" scrolling="no" src="//www.youtube.com/embed/'.$attributes['id'];if(isset($attributes['list']))$html.='?list='.$attributes['list'];if(isset($attributes['t'])||isset($attributes['m'])){if(isset($attributes['list']))$html.='&amp;';else$html.='?';$html.='start=';if(isset($attributes['t']))$html.=$attributes['t'];elseif(isset($attributes['h']))$html.=\htmlspecialchars($attributes['h']*3600+$attributes['m']*60+$attributes['s'],2);else$html.=\htmlspecialchars($attributes['m']*60+$attributes['s'],2);}$html.='"></iframe>';}
		return $html;
	}
}